Index: trunk/src/main.cpp
===================================================================
--- trunk/src/main.cpp	(revision 16)
+++ trunk/src/main.cpp	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 Lёppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -46,3 +46,2 @@
 	return app.exec();
 }
-
Index: trunk/src/mainwindow.cpp
===================================================================
--- trunk/src/mainwindow.cpp	(revision 16)
+++ trunk/src/mainwindow.cpp	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 Lёppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -23,4 +23,7 @@
 
 #include <QtGui>
+#ifndef Q_OS_WINCE
+	#include <QPrintDialog>
+#endif // Q_OS_WINCE
 #include "mainwindow.h"
 
@@ -32,11 +35,21 @@
 	setupUi(this);
 	connect(actionSettingsSettings,SIGNAL(triggered()),this,SLOT(ChangeSettings()));
+#ifndef Q_OS_WINCE
+	connect(actionFilePrintSetup,SIGNAL(triggered()),this,SLOT(PrintSetup()));
+#endif // Q_OS_WINCE
 	connect(buttonSolve,SIGNAL(clicked()),this,SLOT(Solve()));
 	connect(buttonRandom,SIGNAL(clicked()),this,SLOT(Random()));
 	connect(spinCities,SIGNAL(valueChanged(int)),this,SLOT(CitiesNumberChanged(int)));
+QRect rect = geometry();
+#ifdef Q_OS_WINCE
+	// HACK: Fix for all tabWidget elements becoming "unclickable" if making it central widget.
+	rect.setSize(QApplication::desktop()->availableGeometry().size());
+	rect.setHeight(rect.height() - (QApplication::desktop()->screenGeometry().height() - QApplication::desktop()->availableGeometry().height()));
+	tabWidget->resize(rect.width(),rect.height() - toolBar->size().height());
+#else
 	// Centering MainWindow
 	// TODO: Loading of saved window state
-QRect rect = geometry();
-	rect.moveCenter(QApplication::desktop()->screenGeometry(QApplication::desktop()->primaryScreen()).center());
+	rect.moveCenter(QApplication::desktop()->availableGeometry().center());
+#endif // Q_OS_WINCE
 	setGeometry(rect);
 	qsrand(QDateTime().currentDateTime().toTime_t());
@@ -63,4 +76,12 @@
 	}
 }
+
+#ifndef Q_OS_WINCE
+void MainWindow::PrintSetup()
+{
+QPrintDialog pd;
+	pd.exec();
+}
+#endif // Q_OS_WINCE
 
 void MainWindow::Random()
@@ -93,3 +114,2 @@
 	// tabWidget->setCurrentIndex(1);
 }
-
Index: trunk/src/mainwindow.h
===================================================================
--- trunk/src/mainwindow.h	(revision 16)
+++ trunk/src/mainwindow.h	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 Lёppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -26,5 +26,9 @@
 
 #include <QMainWindow>
-#include "ui_mainwindow.h"
+#ifdef Q_OS_WINCE
+	#include "ui_mainwindow.ce.h"
+#else
+	#include "ui_mainwindow.h"
+#endif // Q_OS_WINCE
 #include "settingsdialog.h"
 #include "tspsolver.h"
@@ -38,4 +42,7 @@
 private slots:
 	void ChangeSettings();
+#ifndef Q_OS_WINCE
+	void PrintSetup();
+#endif // Q_OS_WINCE
 	void Solve();
 	void Random();
@@ -48,3 +55,2 @@
 
 #endif // MAINWINDOW_H
-
Index: trunk/src/resource.h
===================================================================
--- trunk/src/resource.h	(revision 17)
+++ trunk/src/resource.h	(revision 17)
@@ -0,0 +1,11 @@
+/*
+ *  TSPSG - TSP Solver and Generator
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
+ *
+ *  $Id$
+ *  $URL$
+ *
+ *  This file is part of TSPSG.
+ */
+
+#define IDI_APPICON 101
Index: trunk/src/settingsdialog.cpp
===================================================================
--- trunk/src/settingsdialog.cpp	(revision 16)
+++ trunk/src/settingsdialog.cpp	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 Lёppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -24,4 +24,5 @@
 #include <QMessageBox>
 #include <QStatusTipEvent>
+#include <QFontDialog>
 #include "settingsdialog.h"
 
@@ -33,7 +34,9 @@
 	connect(buttonCancel,SIGNAL(clicked()),this,SLOT(reject()));
 	connect(spinRandMin,SIGNAL(valueChanged(int)),this,SLOT(spinRandMinValueChanged(int)));
+	connect(buttonFont,SIGNAL(clicked()),this,SLOT(buttonFontClicked()));
 //	setWindowFlags(Qt::Dialog | Qt::CustomizeWindowHint | Qt::WindowTitleHint | Qt::MSWindowsFixedSizeDialogHint);
 	setWindowFlags(windowFlags() ^ Qt::WindowContextHelpButtonHint);
 	layout()->setSizeConstraint(layout()->SetFixedSize);
+#ifndef Q_OS_WINCE
 	// Setting initial text of dialog hint label to own status tip
 	// text.
@@ -43,6 +46,8 @@
 	labelHint->setMaximumHeight(labelHint->height());
 	labelHint->setMinimumHeight(labelHint->height());
+#endif // Q_OS_WINCE
 }
 
+#ifndef Q_OS_WINCE
 bool SettingsDialog::event(QEvent *ev)
 {
@@ -60,3 +65,10 @@
 		return QDialog::event(ev);
 }
+#endif // Q_OS_WINCE
 
+void SettingsDialog::buttonFontClicked()
+{
+	// TODO: Pass current font to dialog and save selected.
+QFontDialog fd;
+	fd.exec();
+}
Index: trunk/src/settingsdialog.h
===================================================================
--- trunk/src/settingsdialog.h	(revision 16)
+++ trunk/src/settingsdialog.h	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 Lёppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -26,5 +26,9 @@
 
 #include <QDialog>
-#include "ui_settingsdialog.h"
+#ifdef Q_OS_WINCE
+	#include "ui_settingsdialog.ce.h"
+#else
+	#include "ui_settingsdialog.h"
+#endif // Q_OS_WINCE
 
 class SettingsDialog: public QDialog, public Ui::SettingsDialog
@@ -35,10 +39,12 @@
 
 private:
+#ifndef WINCE
 	bool event(QEvent *);
+#endif
 
 private slots:
 	void spinRandMinValueChanged(int val) { spinRandMax->setMinimum(val + 1); }
+	void buttonFontClicked();
 };
 
 #endif // SETTINGSDIALOG_H
-
Index: trunk/src/tspmodel.cpp
===================================================================
--- trunk/src/tspmodel.cpp	(revision 16)
+++ trunk/src/tspmodel.cpp	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 Lёppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -45,8 +45,11 @@
 }
 
-QVariant CTSPModel::headerData(int section, Qt::Orientation, int role) const
+QVariant CTSPModel::headerData(int section, Qt::Orientation orientation, int role) const
 {
 	if (role == Qt::DisplayRole)
-		return trUtf8("Город %1").arg(section + 1);
+		if (orientation == Qt::Vertical)
+			return trUtf8("Город %1").arg(section + 1);
+		else
+			return trUtf8("%1").arg(section + 1);
 	return QVariant();
 }
@@ -143,3 +146,2 @@
 	emit dataChanged(index(0,0),index(nCities - 1,nCities - 1));
 }
-
Index: trunk/src/tspmodel.h
===================================================================
--- trunk/src/tspmodel.h	(revision 16)
+++ trunk/src/tspmodel.h	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 Lёppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -60,3 +60,2 @@
 
 #endif // TSPMODEL_H
-
Index: trunk/src/tspsolver.cpp
===================================================================
--- trunk/src/tspsolver.cpp	(revision 16)
+++ trunk/src/tspsolver.cpp	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 L¸ppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -58,3 +58,2 @@
 	return step;
 }
-
Index: trunk/src/tspsolver.h
===================================================================
--- trunk/src/tspsolver.h	(revision 16)
+++ trunk/src/tspsolver.h	(revision 17)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG - TSP Solver and Generator
- *  Copyright (C) 2007 L¸ppa <lacontacts[at]gmail[dot]com>
+ *  Copyright (C) 2007-2009 Lёppa <contacts[at]oleksii[dot]name>
  *
  *  $Id$
@@ -53,3 +53,2 @@
 
 #endif // TSPSOLVER_H
-