Index: src/_.h
===================================================================
--- src/_.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/_.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG: TSP Solver and Generator
- *  Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ *  Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/defaults.h
===================================================================
--- src/defaults.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/defaults.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file defaults.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/globals.cpp
===================================================================
--- src/globals.cpp	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/globals.cpp	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG: TSP Solver and Generator
- *  Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ *  Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/globals.h
===================================================================
--- src/globals.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/globals.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file globals.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/main.cpp
===================================================================
--- src/main.cpp	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/main.cpp	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG: TSP Solver and Generator
- *  Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ *  Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/mainwindow.cpp
===================================================================
--- src/mainwindow.cpp	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/mainwindow.cpp	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG: TSP Solver and Generator
- *  Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ *  Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/mainwindow.h
===================================================================
--- src/mainwindow.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/mainwindow.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file mainwindow.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
@@ -54,5 +54,5 @@
 /*!
  * \brief Class for handling Main Window UI and logic.
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  */
 class MainWindow: public QMainWindow, Ui::MainWindow
Index: src/os.h
===================================================================
--- src/os.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/os.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file os.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/pch.h
===================================================================
--- src/pch.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/pch.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file pch.h
- * \author Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/resource.h
===================================================================
--- src/resource.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/resource.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file resource.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/settingsdialog.cpp
===================================================================
--- src/settingsdialog.cpp	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/settingsdialog.cpp	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG: TSP Solver and Generator
- *  Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ *  Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/settingsdialog.h
===================================================================
--- src/settingsdialog.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/settingsdialog.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file settingsdialog.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
@@ -35,5 +35,5 @@
 /*!
  * \brief Class for handling Settings Dialog UI and logic.
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  */
 class SettingsDialog: public QDialog, Ui::SettingsDialog
Index: src/tspmodel.cpp
===================================================================
--- src/tspmodel.cpp	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/tspmodel.cpp	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG: TSP Solver and Generator
- *  Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ *  Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/tspmodel.h
===================================================================
--- src/tspmodel.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/tspmodel.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file tspmodel.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
@@ -37,5 +37,5 @@
 /*!
  * \brief This class implements table model for manipulating a task.
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  */
 class CTSPModel: public QAbstractTableModel
Index: src/tspsolver.cpp
===================================================================
--- src/tspsolver.cpp	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/tspsolver.cpp	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*
  *  TSPSG: TSP Solver and Generator
- *  Copyright (C) 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ *  Copyright (C) 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
Index: src/tspsolver.h
===================================================================
--- src/tspsolver.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/tspsolver.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file tspsolver.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $
@@ -104,5 +104,5 @@
 /*!
  * \brief This class solves Travelling Salesman Problem task.
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  */
 class CTSPSolver: public QObject
Index: src/version.h
===================================================================
--- src/version.h	(revision 4cc94b19adaa7fefe64efbdfcf236867f7941e07)
+++ src/version.h	(revision 21c03af7870b12dcf1cc3503c398191b8b8188e9)
@@ -1,5 +1,5 @@
 /*!
  * \file version.h
- * \author Copyright &copy; 2007-2012 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
+ * \author Copyright &copy; 2007-2013 Oleksii Serdiuk <contacts[at]oleksii[dot]name>
  *
  *  $Id: $Format:%h %ai %an$ $