Index: trunk/ui/mainwindow.ui
===================================================================
--- trunk/ui/mainwindow.ui	(revision 21)
+++ trunk/ui/mainwindow.ui	(revision 27)
@@ -12,5 +12,5 @@
   </property>
   <property name="windowTitle">
-   <string>Задача коммивояжера</string>
+   <string>Travelling salesman problem</string>
   </property>
   <property name="windowIcon">
@@ -33,5 +33,5 @@
       <widget class="QWidget" name="tabTask">
        <attribute name="title">
-        <string>Задача</string>
+        <string>Task</string>
        </attribute>
        <layout class="QVBoxLayout">
@@ -54,5 +54,5 @@
            <widget class="QLabel" name="labelVariant">
             <property name="text">
-             <string>&amp;Вариант:</string>
+             <string>&amp;Variant:</string>
             </property>
             <property name="buddy">
@@ -67,5 +67,5 @@
             </property>
             <property name="statusTip">
-             <string>Номер варианта</string>
+             <string>Number of variant</string>
             </property>
             <property name="minimum">
@@ -77,5 +77,5 @@
            <widget class="QLabel" name="labelCities">
             <property name="text">
-             <string>&amp;Городов:</string>
+             <string>&amp;Cities:</string>
             </property>
             <property name="buddy">
@@ -90,5 +90,5 @@
             </property>
             <property name="statusTip">
-             <string>Количество городов, которые обходит коммивояжер</string>
+             <string>Number of cities</string>
             </property>
             <property name="minimum">
@@ -121,5 +121,5 @@
          <widget class="QTableView" name="taskView">
           <property name="statusTip">
-           <string>Стоимости переходов/переездов из города в город</string>
+           <string>Cost of travel from city to city</string>
           </property>
           <property name="selectionMode">
@@ -149,8 +149,8 @@
             </property>
             <property name="statusTip">
-             <string>Заполнить таблицу случайными значениями</string>
+             <string>Fill table with random numbers</string>
             </property>
             <property name="text">
-             <string>Случайно</string>
+             <string>Random</string>
             </property>
            </widget>
@@ -162,8 +162,8 @@
             </property>
             <property name="statusTip">
-             <string>Решить текущую задачу</string>
+             <string>Solve current task</string>
             </property>
             <property name="text">
-             <string>Решить</string>
+             <string>Solve</string>
             </property>
             <property name="icon">
@@ -179,5 +179,5 @@
       <widget class="QWidget" name="tabSolution">
        <attribute name="title">
-        <string>Решение</string>
+        <string>Solution</string>
        </attribute>
        <layout class="QVBoxLayout">
@@ -196,5 +196,5 @@
             </property>
             <property name="statusTip">
-             <string>Ход решения</string>
+             <string>Solution steps</string>
             </property>
             <property name="readOnly">
@@ -206,5 +206,5 @@
            <widget class="QGraphicsView" name="graphicsView">
             <property name="statusTip">
-             <string>Граф решения</string>
+             <string>Solution graph</string>
             </property>
            </widget>
@@ -234,5 +234,5 @@
     </property>
     <property name="title">
-     <string>&amp;Файл</string>
+     <string>&amp;File</string>
     </property>
     <widget class="QMenu" name="menuFileSave">
@@ -241,5 +241,5 @@
      </property>
      <property name="title">
-      <string>Со&amp;хранить</string>
+      <string>&amp;Save</string>
      </property>
      <property name="icon">
@@ -264,5 +264,5 @@
    <widget class="QMenu" name="menuSettings">
     <property name="title">
-     <string>&amp;Настройки</string>
+     <string>&amp;Settings</string>
     </property>
     <addaction name="actionSettingsSettings"/>
@@ -270,5 +270,5 @@
    <widget class="QMenu" name="menuHelp">
     <property name="title">
-     <string>&amp;Помощь</string>
+     <string>&amp;Help</string>
     </property>
     <addaction name="actionHelpContents"/>
@@ -313,8 +313,8 @@
    </property>
    <property name="text">
-    <string>&amp;Настройка печати</string>
-   </property>
-   <property name="statusTip">
-    <string>Настроить принтер для печати</string>
+    <string>P&amp;rint setup...</string>
+   </property>
+   <property name="statusTip">
+    <string>Setup printing</string>
    </property>
   </action>
@@ -328,8 +328,8 @@
    </property>
    <property name="text">
-    <string>&amp;Печать...</string>
-   </property>
-   <property name="statusTip">
-    <string>Распечатать результаты решения</string>
+    <string>&amp;Print...</string>
+   </property>
+   <property name="statusTip">
+    <string>Print solution results</string>
    </property>
    <property name="shortcut">
@@ -342,8 +342,11 @@
    </property>
    <property name="text">
-    <string>&amp;Ход решения</string>
-   </property>
-   <property name="statusTip">
-    <string>Сохранить только хоод решения</string>
+    <string>Solution st&amp;eps</string>
+   </property>
+   <property name="toolTip">
+    <string>Save solution steps</string>
+   </property>
+   <property name="statusTip">
+    <string>Save solution steps only</string>
    </property>
   </action>
@@ -353,8 +356,11 @@
    </property>
    <property name="text">
-    <string>&amp;Граф решения</string>
-   </property>
-   <property name="statusTip">
-    <string>Сохранить только граф решения</string>
+    <string>Solution &amp;graph</string>
+   </property>
+   <property name="toolTip">
+    <string>Save solution graph</string>
+   </property>
+   <property name="statusTip">
+    <string>Save solution graph only</string>
    </property>
   </action>
@@ -364,8 +370,11 @@
    </property>
    <property name="text">
-    <string>&amp;Решение</string>
-   </property>
-   <property name="statusTip">
-    <string>Сохранить ход и граф решения</string>
+    <string>&amp;Solution</string>
+   </property>
+   <property name="toolTip">
+    <string>Save solution</string>
+   </property>
+   <property name="statusTip">
+    <string>Save solution steps and graph</string>
    </property>
   </action>
@@ -376,8 +385,14 @@
    </property>
    <property name="text">
-    <string>&amp;Создать</string>
-   </property>
-   <property name="statusTip">
-    <string>Создать новую задачу</string>
+    <string>&amp;New</string>
+   </property>
+   <property name="iconText">
+    <string>New</string>
+   </property>
+   <property name="toolTip">
+    <string>New task</string>
+   </property>
+   <property name="statusTip">
+    <string>Create new task</string>
    </property>
    <property name="shortcut">
@@ -386,4 +401,7 @@
   </action>
   <action name="actionFileOpen">
+   <property name="enabled">
+    <bool>false</bool>
+   </property>
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
@@ -391,11 +409,14 @@
    </property>
    <property name="text">
-    <string>&amp;Открыть</string>
+    <string>&amp;Open...</string>
+   </property>
+   <property name="iconText">
+    <string>Open...</string>
    </property>
    <property name="toolTip">
-    <string>Открыть задачу</string>
-   </property>
-   <property name="statusTip">
-    <string>Открыть сохраненное условие задачи</string>
+    <string>Open task</string>
+   </property>
+   <property name="statusTip">
+    <string>Open saved task</string>
    </property>
    <property name="shortcut">
@@ -409,11 +430,17 @@
    </property>
    <property name="text">
-    <string>&amp;Параметры</string>
-   </property>
-   <property name="statusTip">
-    <string>Настройка параметров программмы</string>
+    <string>&amp;Preferences...</string>
+   </property>
+   <property name="iconText">
+    <string>Preferences...</string>
+   </property>
+   <property name="statusTip">
+    <string>Application preferences</string>
    </property>
   </action>
   <action name="actionHelpContents">
+   <property name="enabled">
+    <bool>false</bool>
+   </property>
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
@@ -421,11 +448,14 @@
    </property>
    <property name="text">
-    <string>&amp;Содежание</string>
-   </property>
-   <property name="statusTip">
-    <string>Вызвать справку по программе</string>
+    <string>&amp;Contents</string>
+   </property>
+   <property name="statusTip">
+    <string>Open help contents</string>
    </property>
   </action>
   <action name="actionHelpContextual">
+   <property name="enabled">
+    <bool>false</bool>
+   </property>
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
@@ -433,8 +463,8 @@
    </property>
    <property name="text">
-    <string>&amp;Контекстная справка</string>
-   </property>
-   <property name="statusTip">
-    <string>Вызвать контекстную справку</string>
+    <string>&amp;Context help</string>
+   </property>
+   <property name="statusTip">
+    <string>Open context help</string>
    </property>
   </action>
@@ -445,8 +475,11 @@
    </property>
    <property name="text">
-    <string>&amp;Про...</string>
-   </property>
-   <property name="statusTip">
-    <string>Получить информацию о программе</string>
+    <string>&amp;About...</string>
+   </property>
+   <property name="iconText">
+    <string>About...</string>
+   </property>
+   <property name="statusTip">
+    <string>About application</string>
    </property>
   </action>
@@ -457,11 +490,14 @@
    </property>
    <property name="text">
-    <string>В&amp;ыход</string>
-   </property>
-   <property name="statusTip">
-    <string>Выйти из программы</string>
+    <string>E&amp;xit</string>
+   </property>
+   <property name="statusTip">
+    <string>Exit application</string>
    </property>
   </action>
   <action name="actionFileSaveTask">
+   <property name="enabled">
+    <bool>false</bool>
+   </property>
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
@@ -469,14 +505,14 @@
    </property>
    <property name="text">
-    <string>&amp;Задачу</string>
+    <string>&amp;Task...</string>
    </property>
    <property name="iconText">
-    <string>Сохранить</string>
+    <string>Task...</string>
    </property>
    <property name="toolTip">
-    <string>Сохранить задачу</string>
-   </property>
-   <property name="statusTip">
-    <string>Сохранить условие задачи в файл</string>
+    <string>Save task</string>
+   </property>
+   <property name="statusTip">
+    <string>Save task to file</string>
    </property>
    <property name="shortcut">