Index: README.md
===================================================================
--- README.md	(revision b4b4f8d479f3c6fcc9233fc9710b88dba475e4a7)
+++ README.md	(revision 30eb4f72f98cbf31e7f3f7ed3ea49152e8520191)
@@ -57,7 +57,7 @@
     see <http://www.oxygen-icons.org/>.
 
-  * Country flag icons used in TSPSG are part of the free **Flag Icons**
-    collection created by **IconDrawer**,
-    see <http://www.icondrawer.com/>.
+  * Country flag icons used in TSPSG are part of **Flag Icons** by
+    **GoSquared** licensed under the terms of *MIT License*,
+    see <https://www.gosquared.com/>.
 
   * TSPSG comes with the default "embedded" font **DejaVu LGC Sans
Index: resources/icons/l10n/Hello.txt
===================================================================
--- resources/icons/l10n/Hello.txt	(revision 30eb4f72f98cbf31e7f3f7ed3ea49152e8520191)
+++ resources/icons/l10n/Hello.txt	(revision 30eb4f72f98cbf31e7f3f7ed3ea49152e8520191)
@@ -0,0 +1,70 @@
+Flag Icons by GoSquared (http://www.gosquared.com/)
+
+Version: 2.6
+Last Updated: 8th March 2013
+
+Usage:
+  You're free to use this set for both personal and commercial projects
+  (MIT License, see LICENSE.txt), and a back-link is not required
+  (but certainly appreciated).
+
+
+Inclusion of flags:
+  This icon set includes all flags for recognized sovereign states, plus several other major
+  territories. As a rule, disputed states ARE included without discrimination.
+
+
+Contacting Us:
+  If you have any suggestions of corrections (incorrectly named, missing, or out-of-date flags etc.),
+  then don't hesitate to get in touch at support@gosquared.com and we will do our best
+  to rectify any mistakes or omissions.
+
+
+Changelog:
+
+ * 2.6: 8th March 2013
+     Added Saint Martin to bring total now to 260
+
+ * 2.5: 3rd March 2013
+     Couple more missing flags:
+       Canary Islands
+       Curaçao
+
+ * 2.4: 2nd March 2013
+     Added a couple more missing:
+       Basque Country
+       Martinique
+     Added "unknown"
+     Cleaned out some buggy files called ".png" that crept in somehow
+
+ * 2.3: 26th January 2013
+     Added more missing flags:
+       French Polynesia
+       Frensh Southern Territories
+       Tokelau
+       Wallis and Futuna
+     Removed Kosovo's ISO code (it doesn't have one, KV was wrong)
+     Corrected East Timor's ISO code (TP -> TL)
+
+ * 2.2: 29th October 2012
+     Added some missing flags:
+       British Antarctic Territories
+       Christmas Island
+       Cocos (Keeling) Islands
+       Cook Islands
+       Gibraltar
+       Mayotte
+       New Caledonia
+       Niue
+     Added ico and icns formats
+     Fixed problem where all flags in flats/flat had no extension (oops!)
+     Fixed alignment of Nepal overlay at 48x48
+
+ * 2.1: 19th October 2012
+     Fixed incorrect ISO code for Montenegro (CS -> ME)
+
+ * 2.0: 18th October 2012
+     Fully revamped with new "shiny" style, updated with changed and new flags
+
+ * 1.0: 16th September 2010
+     First created. Icon set containing 2400 flag icons
Index: resources/icons/l10n/LICENSE.txt
===================================================================
--- resources/icons/l10n/LICENSE.txt	(revision 30eb4f72f98cbf31e7f3f7ed3ea49152e8520191)
+++ resources/icons/l10n/LICENSE.txt	(revision 30eb4f72f98cbf31e7f3f7ed3ea49152e8520191)
@@ -0,0 +1,19 @@
+Copyright (c) 2013 Go Squared Ltd. http://www.gosquared.com/
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+THE SOFTWARE.
Index: src/mainwindow.cpp
===================================================================
--- src/mainwindow.cpp	(revision b4b4f8d479f3c6fcc9233fc9710b88dba475e4a7)
+++ src/mainwindow.cpp	(revision 30eb4f72f98cbf31e7f3f7ed3ea49152e8520191)
@@ -768,7 +768,7 @@
         "see <a href=\"http://www.oxygen-icons.org/\">www.oxygen-icons.org</a><br>\n"
         "<br>\n"
-        "Country flag icons used in %1 are part of the free "
-        "<b>Flag&nbsp;Icons</b> collection created by <b>IconDrawer</b>,<br>\n"
-        "see <a href=\"http://www.icondrawer.com/\">www.icondrawer.com</a><br>\n"
+        "Country flag icons used in %1 are part of <b>Flag Icons</b> by "
+        "<b>GoSquared</b> licensed under the terms of MIT License,<br>\n"
+        "see <a href=\"https://www.gosquared.com/\">www.gosquared.com</a><br>\n"
         "<br>\n"
         "%1 comes with the default \"embedded\" font <b>DejaVu&nbsp;LGC&nbsp;Sans&nbsp;"