Index: trunk/i18n/ru.ts
===================================================================
--- trunk/i18n/ru.ts	(revision 35)
+++ trunk/i18n/ru.ts	(revision 37)
@@ -113,64 +113,81 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
-        <location filename="../src/mainwindow.cpp" line="292"/>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../src/mainwindow.cpp" line="127"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>Language change</source>
         <translation>Смена языка</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
+        <location filename="../src/mainwindow.cpp" line="127"/>
         <source>Unable to load translation language.</source>
         <translation>Невозможно загрузить перевод.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="159"/>
+        <location filename="../src/mainwindow.cpp" line="173"/>
         <source>All Supported Formats</source>
         <translation>Все поддерживаемые форматы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="162"/>
-        <location filename="../src/mainwindow.cpp" line="177"/>
+        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="196"/>
         <source>All Files</source>
         <translation>Все файлы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="160"/>
-        <location filename="../src/mainwindow.cpp" line="161"/>
+        <location filename="../src/mainwindow.cpp" line="174"/>
+        <location filename="../src/mainwindow.cpp" line="175"/>
         <source>%1 Task Files</source>
         <translation>Файлы задач %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <source>New Task</source>
+        <translation>Новая задача</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Would you like to save changes in current task?</source>
+        <translation>Желаете сохранить изменения в текущей задаче?</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <source>Task Open</source>
+        <translation>Открытие задания</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="195"/>
         <source>%1 Task File</source>
         <translation>Файл задачи %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Data error</source>
         <translation>Ошибка в данных</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>Solution error</source>
         <translation>Ошибка при решении</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>There was an error while solving the task.</source>
         <translation>Во время решения задачи возникла ошибка.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="292"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Язык будет автоматически определен при следующем запуске приложения.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -181,8 +198,11 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="17"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Application Close</source>
+        <translation>Закрытие приложения</translation>
+    </message>
+    <message>
         <source>Travelling salesman problem</source>
-        <translation>Задача коммивояжера</translation>
+        <translation type="obsolete">Задача коммивояжера</translation>
     </message>
     <message>
@@ -271,6 +291,6 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="558"/>
-        <location filename="../ui/mainwindow.ui" line="571"/>
+        <location filename="../ui/mainwindow.ce.ui" line="559"/>
+        <location filename="../ui/mainwindow.ui" line="572"/>
         <source>&amp;Save</source>
         <translation>Со&amp;хранить</translation>
@@ -283,4 +303,10 @@
     </message>
     <message>
+        <location filename="../ui/mainwindow.ce.ui" line="17"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
+        <source>Travelling salesman problem[*]</source>
+        <translation>Задача коммивояжера[*]</translation>
+    </message>
+    <message>
         <location filename="../ui/mainwindow.ce.ui" line="262"/>
         <location filename="../ui/mainwindow.ui" line="240"/>
@@ -301,237 +327,260 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="349"/>
-        <location filename="../ui/mainwindow.ui" line="362"/>
+        <location filename="../ui/mainwindow.ce.ui" line="350"/>
+        <location filename="../ui/mainwindow.ui" line="363"/>
         <source>Solution st&amp;eps</source>
         <translation>&amp;Ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="352"/>
-        <location filename="../ui/mainwindow.ui" line="365"/>
+        <location filename="../ui/mainwindow.ce.ui" line="353"/>
+        <location filename="../ui/mainwindow.ui" line="366"/>
         <source>Save solution steps</source>
         <translation>Сохранить ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="355"/>
-        <location filename="../ui/mainwindow.ui" line="368"/>
+        <location filename="../ui/mainwindow.ce.ui" line="356"/>
+        <location filename="../ui/mainwindow.ui" line="369"/>
         <source>Save solution steps only</source>
         <translation>Сохранить только ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="363"/>
-        <location filename="../ui/mainwindow.ui" line="376"/>
+        <location filename="../ui/mainwindow.ce.ui" line="364"/>
+        <location filename="../ui/mainwindow.ui" line="377"/>
         <source>Solution &amp;graph</source>
         <translation>&amp;Граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="366"/>
-        <location filename="../ui/mainwindow.ui" line="379"/>
+        <location filename="../ui/mainwindow.ce.ui" line="367"/>
+        <location filename="../ui/mainwindow.ui" line="380"/>
         <source>Save solution graph</source>
         <translation>Сохранить граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="369"/>
-        <location filename="../ui/mainwindow.ui" line="382"/>
+        <location filename="../ui/mainwindow.ce.ui" line="370"/>
+        <location filename="../ui/mainwindow.ui" line="383"/>
         <source>Save solution graph only</source>
         <translation>Сохранить только граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="377"/>
-        <location filename="../ui/mainwindow.ui" line="390"/>
+        <location filename="../ui/mainwindow.ce.ui" line="378"/>
+        <location filename="../ui/mainwindow.ui" line="391"/>
         <source>&amp;Solution</source>
         <translation>&amp;Решение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="380"/>
-        <location filename="../ui/mainwindow.ui" line="393"/>
+        <location filename="../ui/mainwindow.ce.ui" line="381"/>
+        <location filename="../ui/mainwindow.ui" line="394"/>
         <source>Save solution</source>
         <translation>Сохранить решение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="383"/>
-        <location filename="../ui/mainwindow.ui" line="396"/>
+        <location filename="../ui/mainwindow.ce.ui" line="384"/>
+        <location filename="../ui/mainwindow.ui" line="397"/>
         <source>Save solution steps and graph</source>
         <translation>Сохранить ход и граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="392"/>
-        <location filename="../ui/mainwindow.ui" line="405"/>
+        <location filename="../ui/mainwindow.ce.ui" line="393"/>
+        <location filename="../ui/mainwindow.ui" line="406"/>
         <source>&amp;New</source>
         <translation>&amp;Создать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="395"/>
-        <location filename="../ui/mainwindow.ui" line="408"/>
+        <location filename="../ui/mainwindow.ce.ui" line="396"/>
+        <location filename="../ui/mainwindow.ui" line="409"/>
         <source>New</source>
         <translation>Создать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="398"/>
-        <location filename="../ui/mainwindow.ui" line="411"/>
+        <location filename="../ui/mainwindow.ce.ui" line="399"/>
+        <location filename="../ui/mainwindow.ui" line="412"/>
         <source>New task</source>
         <translation>Создать задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="401"/>
-        <location filename="../ui/mainwindow.ui" line="414"/>
+        <location filename="../ui/mainwindow.ce.ui" line="402"/>
+        <location filename="../ui/mainwindow.ui" line="415"/>
         <source>Create new task</source>
         <translation>Создать новую задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="404"/>
-        <location filename="../ui/mainwindow.ui" line="417"/>
+        <location filename="../ui/mainwindow.ce.ui" line="405"/>
+        <location filename="../ui/mainwindow.ui" line="418"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="413"/>
-        <location filename="../ui/mainwindow.ui" line="426"/>
+        <location filename="../ui/mainwindow.ce.ui" line="414"/>
+        <location filename="../ui/mainwindow.ui" line="427"/>
         <source>&amp;Open...</source>
         <translation>&amp;Открыть...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="416"/>
-        <location filename="../ui/mainwindow.ui" line="429"/>
+        <location filename="../ui/mainwindow.ce.ui" line="417"/>
+        <location filename="../ui/mainwindow.ui" line="430"/>
         <source>Open...</source>
         <translation>Открыть...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="419"/>
-        <location filename="../ui/mainwindow.ui" line="432"/>
+        <location filename="../ui/mainwindow.ce.ui" line="420"/>
+        <location filename="../ui/mainwindow.ui" line="433"/>
         <source>Open task</source>
         <translation>Открыть задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="422"/>
-        <location filename="../ui/mainwindow.ui" line="435"/>
+        <location filename="../ui/mainwindow.ce.ui" line="423"/>
+        <location filename="../ui/mainwindow.ui" line="436"/>
         <source>Open saved task</source>
         <translation>Открыть сохраненное условие задачи</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="425"/>
-        <location filename="../ui/mainwindow.ui" line="438"/>
+        <location filename="../ui/mainwindow.ce.ui" line="426"/>
+        <location filename="../ui/mainwindow.ui" line="439"/>
         <source>Ctrl+O</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="434"/>
-        <location filename="../ui/mainwindow.ui" line="447"/>
+        <location filename="../ui/mainwindow.ce.ui" line="435"/>
+        <location filename="../ui/mainwindow.ui" line="448"/>
         <source>&amp;Preferences...</source>
         <translation>&amp;Параметры...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="437"/>
-        <location filename="../ui/mainwindow.ui" line="450"/>
+        <location filename="../ui/mainwindow.ce.ui" line="438"/>
+        <location filename="../ui/mainwindow.ui" line="451"/>
         <source>Preferences...</source>
         <translation>Параметры...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="440"/>
-        <location filename="../ui/mainwindow.ui" line="453"/>
+        <location filename="../ui/mainwindow.ce.ui" line="441"/>
+        <location filename="../ui/mainwindow.ui" line="454"/>
         <source>Application preferences</source>
         <translation>Настройка параметров программмы</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="452"/>
-        <location filename="../ui/mainwindow.ui" line="465"/>
+        <location filename="../ui/mainwindow.ce.ui" line="453"/>
+        <location filename="../ui/mainwindow.ui" line="466"/>
         <source>&amp;Contents</source>
         <translation>&amp;Содежание</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="455"/>
-        <location filename="../ui/mainwindow.ui" line="468"/>
+        <location filename="../ui/mainwindow.ce.ui" line="456"/>
+        <location filename="../ui/mainwindow.ui" line="469"/>
         <source>Open help contents</source>
         <translation>Вызвать справку программы</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="467"/>
-        <location filename="../ui/mainwindow.ui" line="480"/>
+        <location filename="../ui/mainwindow.ce.ui" line="468"/>
+        <location filename="../ui/mainwindow.ui" line="481"/>
         <source>&amp;Context help</source>
         <translation>&amp;Контекстная справка</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="470"/>
-        <location filename="../ui/mainwindow.ui" line="483"/>
+        <location filename="../ui/mainwindow.ce.ui" line="471"/>
+        <location filename="../ui/mainwindow.ui" line="484"/>
         <source>Open context help</source>
         <translation>Вызвать контекстную справку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="479"/>
-        <location filename="../ui/mainwindow.ui" line="492"/>
+        <location filename="../ui/mainwindow.ce.ui" line="480"/>
+        <location filename="../ui/mainwindow.ui" line="493"/>
         <source>&amp;About...</source>
         <translation>&amp;Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="482"/>
-        <location filename="../ui/mainwindow.ui" line="495"/>
+        <location filename="../ui/mainwindow.ce.ui" line="483"/>
+        <location filename="../ui/mainwindow.ui" line="496"/>
         <source>About...</source>
         <translation>Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="485"/>
-        <location filename="../ui/mainwindow.ui" line="498"/>
+        <location filename="../ui/mainwindow.ce.ui" line="486"/>
+        <location filename="../ui/mainwindow.ui" line="499"/>
         <source>About application</source>
         <translation>О программе</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="494"/>
-        <location filename="../ui/mainwindow.ui" line="507"/>
+        <location filename="../ui/mainwindow.ce.ui" line="495"/>
+        <location filename="../ui/mainwindow.ui" line="508"/>
         <source>E&amp;xit</source>
         <translation>В&amp;ыход</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="497"/>
-        <location filename="../ui/mainwindow.ui" line="510"/>
+        <location filename="../ui/mainwindow.ce.ui" line="498"/>
+        <location filename="../ui/mainwindow.ui" line="511"/>
         <source>Exit application</source>
         <translation>Выйти из приложения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="506"/>
-        <location filename="../ui/mainwindow.ui" line="519"/>
+        <location filename="../ui/mainwindow.ce.ui" line="507"/>
+        <location filename="../ui/mainwindow.ui" line="520"/>
         <source>&amp;Task...</source>
         <translation>&amp;Задачу...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="509"/>
-        <location filename="../ui/mainwindow.ui" line="522"/>
+        <location filename="../ui/mainwindow.ce.ui" line="510"/>
+        <location filename="../ui/mainwindow.ui" line="523"/>
         <source>Task...</source>
         <translation>Задачу...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="512"/>
-        <location filename="../ui/mainwindow.ce.ui" line="561"/>
-        <location filename="../ui/mainwindow.ui" line="525"/>
-        <location filename="../ui/mainwindow.ui" line="577"/>
+        <location filename="../ui/mainwindow.ce.ui" line="513"/>
+        <location filename="../ui/mainwindow.ce.ui" line="562"/>
+        <location filename="../ui/mainwindow.ui" line="526"/>
+        <location filename="../ui/mainwindow.ui" line="578"/>
         <source>Save task</source>
         <translation>Сохранить задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="515"/>
-        <location filename="../ui/mainwindow.ui" line="528"/>
+        <location filename="../ui/mainwindow.ce.ui" line="516"/>
+        <location filename="../ui/mainwindow.ui" line="529"/>
         <source>Save task to file</source>
         <translation>Сохранить условие задачи в файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="518"/>
-        <location filename="../ui/mainwindow.ui" line="531"/>
+        <location filename="../ui/mainwindow.ce.ui" line="519"/>
+        <location filename="../ui/mainwindow.ui" line="532"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="529"/>
-        <location filename="../ui/mainwindow.ui" line="542"/>
+        <location filename="../ui/mainwindow.ce.ui" line="530"/>
+        <location filename="../ui/mainwindow.ui" line="543"/>
         <source>&amp;Autodetect</source>
         <translation>&amp;Автоопределение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="546"/>
+        <location filename="../ui/mainwindow.ce.ui" line="547"/>
         <source>English</source>
         <translation>Английский</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="564"/>
-        <location filename="../ui/mainwindow.ui" line="580"/>
+        <location filename="../ui/mainwindow.ce.ui" line="565"/>
+        <location filename="../ui/mainwindow.ui" line="581"/>
         <source>Save current task</source>
         <translation>Сохранить текущую задачу</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="590"/>
+        <source>About &amp;Qt...</source>
+        <translation>Про &amp;Qt...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="577"/>
+        <location filename="../ui/mainwindow.ui" line="593"/>
+        <source>About Qt...</source>
+        <translation>Про Qt...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="580"/>
+        <source>About Qt</source>
+        <translation>Про Qt</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="583"/>
+        <location filename="../ui/mainwindow.ui" line="596"/>
+        <source>About Qt library</source>
+        <translation>Про библиотеку Qt</translation>
     </message>
     <message>
@@ -548,42 +597,42 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="333"/>
+        <location filename="../ui/mainwindow.ui" line="334"/>
         <source>P&amp;rint setup...</source>
         <translation>&amp;Настройка печати...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="336"/>
+        <location filename="../ui/mainwindow.ui" line="337"/>
         <source>Setup printing</source>
         <translation>Настроить печать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="349"/>
         <source>&amp;Print...</source>
         <translation>&amp;Печать...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="352"/>
         <source>Print solution results</source>
         <translation>Распечатать результаты решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="355"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="575"/>
         <source>Save</source>
         <translation>Сохранить</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="532"/>
-        <location filename="../ui/mainwindow.ui" line="545"/>
+        <location filename="../ui/mainwindow.ce.ui" line="533"/>
+        <location filename="../ui/mainwindow.ui" line="546"/>
         <source>Detect language automatically</source>
         <translation>Определять язык автоматически</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="535"/>
-        <location filename="../ui/mainwindow.ui" line="548"/>
+        <location filename="../ui/mainwindow.ce.ui" line="536"/>
+        <location filename="../ui/mainwindow.ui" line="549"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Определять язык автоматически, основываясь на региональных настройках</translation>