Index: trunk/ui/mainwindow.ui
===================================================================
--- trunk/ui/mainwindow.ui	(revision 37)
+++ trunk/ui/mainwindow.ui	(revision 38)
@@ -154,4 +154,8 @@
              <string>Random</string>
             </property>
+            <property name="icon">
+             <iconset resource="../resources/tspsg.qrc">
+              <normaloff>:/images/icons/roll.png</normaloff>:/images/icons/roll.png</iconset>
+            </property>
            </widget>
           </item>
@@ -169,5 +173,5 @@
             <property name="icon">
              <iconset resource="../resources/tspsg.qrc">
-              <normaloff>:/images/buttons/buttons/OK.png</normaloff>:/images/buttons/buttons/OK.png</iconset>
+              <normaloff>:/images/icons/button_ok.png</normaloff>:/images/icons/button_ok.png</iconset>
             </property>
            </widget>
@@ -242,5 +246,5 @@
      <property name="icon">
       <iconset resource="../resources/tspsg.qrc">
-       <normaloff>:/images/buttons/buttons/Save.png</normaloff>:/images/buttons/buttons/Save.png</iconset>
+       <normaloff>:/images/icons/filesaveas.png</normaloff>:/images/icons/filesaveas.png</iconset>
      </property>
      <addaction name="actionFileSaveTask"/>
@@ -276,5 +280,5 @@
      <property name="icon">
       <iconset resource="../resources/tspsg.qrc">
-       <normaloff>:/images/buttons/buttons/Web.png</normaloff>:/images/buttons/buttons/Web.png</iconset>
+       <normaloff>:/images/icons/locale.png</normaloff>:/images/icons/locale.png</iconset>
      </property>
      <addaction name="actionSettingsLanguageAutodetect"/>
@@ -305,10 +309,4 @@
     <cursorShape>ArrowCursor</cursorShape>
    </property>
-   <property name="iconSize">
-    <size>
-     <width>17</width>
-     <height>18</height>
-    </size>
-   </property>
    <attribute name="toolBarArea">
     <enum>TopToolBarArea</enum>
@@ -329,5 +327,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/PrintSetup.png</normaloff>:/images/buttons/buttons/PrintSetup.png</iconset>
+     <normaloff>:/images/icons/fileprint.png</normaloff>:/images/icons/fileprint.png</iconset>
    </property>
    <property name="text">
@@ -344,5 +342,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/Print.png</normaloff>:/images/buttons/buttons/Print.png</iconset>
+     <normaloff>:/images/icons/fileprint.png</normaloff>:/images/icons/fileprint.png</iconset>
    </property>
    <property name="text">
@@ -401,5 +399,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/Document.png</normaloff>:/images/buttons/buttons/Document.png</iconset>
+     <normaloff>:/images/icons/filenew.png</normaloff>:/images/icons/filenew.png</iconset>
    </property>
    <property name="text">
@@ -422,5 +420,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/OpenFolder.png</normaloff>:/images/buttons/buttons/OpenFolder.png</iconset>
+     <normaloff>:/images/icons/fileopen.png</normaloff>:/images/icons/fileopen.png</iconset>
    </property>
    <property name="text">
@@ -443,5 +441,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/Properties.png</normaloff>:/images/buttons/buttons/Properties.png</iconset>
+     <normaloff>:/images/icons/preferences_system.png</normaloff>:/images/icons/preferences_system.png</iconset>
    </property>
    <property name="text">
@@ -461,5 +459,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/book_open.png</normaloff>:/images/buttons/buttons/book_open.png</iconset>
+     <normaloff>:/images/icons/contents.png</normaloff>:/images/icons/contents.png</iconset>
    </property>
    <property name="text">
@@ -476,8 +474,8 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/Help.png</normaloff>:/images/buttons/buttons/Help.png</iconset>
-   </property>
-   <property name="text">
-    <string>&amp;Context help</string>
+     <normaloff>:/images/icons/help_browser.png</normaloff>:/images/icons/help_browser.png</iconset>
+   </property>
+   <property name="text">
+    <string>Context &amp;Help</string>
    </property>
    <property name="statusTip">
@@ -488,5 +486,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/infoBubble.png</normaloff>:/images/buttons/buttons/infoBubble.png</iconset>
+     <normaloff>:/images/icons/help_about.png</normaloff>:/images/icons/help_about.png</iconset>
    </property>
    <property name="text">
@@ -503,5 +501,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/NoAction.png</normaloff>:/images/buttons/buttons/NoAction.png</iconset>
+     <normaloff>:/images/icons/exit.png</normaloff>:/images/icons/exit.png</iconset>
    </property>
    <property name="text">
@@ -515,5 +513,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/Save.png</normaloff>:/images/buttons/buttons/Save.png</iconset>
+     <normaloff>:/images/icons/filesaveas.png</normaloff>:/images/icons/filesaveas.png</iconset>
    </property>
    <property name="text">
@@ -567,5 +565,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/buttons/buttons/Save.png</normaloff>:/images/buttons/buttons/Save.png</iconset>
+     <normaloff>:/images/icons/filesave.png</normaloff>:/images/icons/filesave.png</iconset>
    </property>
    <property name="text">