Index: trunk/ui/mainwindow.ce.ui
===================================================================
--- trunk/ui/mainwindow.ce.ui	(revision 39)
+++ trunk/ui/mainwindow.ce.ui	(revision 42)
@@ -10,6 +10,6 @@
     <x>0</x>
     <y>0</y>
-    <width>234</width>
-    <height>292</height>
+    <width>225</width>
+    <height>322</height>
    </rect>
   </property>
@@ -22,7 +22,4 @@
   </property>
   <widget class="QWidget" name="centralwidget">
-   <property name="enabled">
-    <bool>true</bool>
-   </property>
    <widget class="QTabWidget" name="tabWidget">
     <property name="enabled">
@@ -31,8 +28,8 @@
     <property name="geometry">
      <rect>
-      <x>0</x>
-      <y>0</y>
-      <width>235</width>
-      <height>240</height>
+      <x>9</x>
+      <y>9</y>
+      <width>207</width>
+      <height>248</height>
      </rect>
     </property>
@@ -206,34 +203,20 @@
       <string>Solution</string>
      </attribute>
-     <layout class="QVBoxLayout" name="_4">
+     <layout class="QVBoxLayout" name="verticalLayout_2">
       <item>
-       <layout class="QHBoxLayout" name="_5">
-        <property name="spacing">
-         <number>0</number>
+       <widget class="QTextEdit" name="solutionText">
+        <property name="enabled">
+         <bool>false</bool>
         </property>
-        <item>
-         <widget class="QTextEdit" name="textEdit">
-          <property name="sizePolicy">
-           <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
-            <horstretch>0</horstretch>
-            <verstretch>0</verstretch>
-           </sizepolicy>
-          </property>
-          <property name="statusTip">
-           <string>Solution steps</string>
-          </property>
-          <property name="readOnly">
-           <bool>true</bool>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QGraphicsView" name="graphicsView">
-          <property name="statusTip">
-           <string>Solution graph</string>
-          </property>
-         </widget>
-        </item>
-       </layout>
+        <property name="statusTip">
+         <string>Solution steps</string>
+        </property>
+        <property name="readOnly">
+         <bool>true</bool>
+        </property>
+        <property name="textInteractionFlags">
+         <set>Qt::TextSelectableByKeyboard|Qt::TextSelectableByMouse</set>
+        </property>
+       </widget>
       </item>
      </layout>
@@ -246,6 +229,6 @@
      <x>0</x>
      <y>0</y>
-     <width>234</width>
-     <height>24</height>
+     <width>225</width>
+     <height>22</height>
     </rect>
    </property>
@@ -270,9 +253,6 @@
        <normaloff>:/images/icons/filesaveas.png</normaloff>:/images/icons/filesaveas.png</iconset>
      </property>
-     <addaction name="actionFileSaveTask"/>
-     <addaction name="separator"/>
-     <addaction name="actionFileSaveResultAll"/>
-     <addaction name="actionFileSaveResultMatrices"/>
-     <addaction name="actionFileSaveResultGraph"/>
+     <addaction name="actionFileSaveAsTask"/>
+     <addaction name="actionFileSaveAsSolution"/>
     </widget>
     <addaction name="actionFileNew"/>
@@ -295,5 +275,5 @@
      </property>
      <property name="title">
-      <string extracomment="Please, append &quot; / Language&quot; when translating this string.">&amp;Language</string>
+      <string comment="Please, append &quot; / Language&quot; when translating this string.">&amp;Language</string>
      </property>
      <property name="icon">
@@ -369,10 +349,13 @@
    </property>
   </action>
-  <action name="actionFileSaveResultAll">
+  <action name="actionFileSaveAsSolution">
    <property name="enabled">
     <bool>false</bool>
    </property>
    <property name="text">
-    <string>&amp;Solution</string>
+    <string>&amp;Solution...</string>
+   </property>
+   <property name="iconText">
+    <string>Solution...</string>
    </property>
    <property name="toolTip">
@@ -497,5 +480,5 @@
    </property>
   </action>
-  <action name="actionFileSaveTask">
+  <action name="actionFileSaveAsTask">
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
@@ -567,5 +550,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/qtlogo-64.png</normaloff>:/images/qtlogo-64.png</iconset>
+     <normaloff>:/images/icons/qtlogo-64.png</normaloff>:/images/icons/qtlogo-64.png</iconset>
    </property>
    <property name="text">
Index: trunk/ui/mainwindow.ui
===================================================================
--- trunk/ui/mainwindow.ui	(revision 39)
+++ trunk/ui/mainwindow.ui	(revision 42)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>640</width>
-    <height>480</height>
+    <width>491</width>
+    <height>400</height>
    </rect>
   </property>
@@ -19,206 +19,196 @@
   </property>
   <widget class="QWidget" name="centralwidget">
-   <layout class="QGridLayout">
-    <item row="0" column="0">
-     <widget class="QTabWidget" name="tabWidget">
-      <property name="sizePolicy">
-       <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
-        <horstretch>0</horstretch>
-        <verstretch>0</verstretch>
-       </sizepolicy>
-      </property>
-      <property name="currentIndex">
-       <number>0</number>
-      </property>
-      <widget class="QWidget" name="tabTask">
-       <attribute name="title">
-        <string>Task</string>
-       </attribute>
-       <layout class="QVBoxLayout">
-        <item>
-         <layout class="QHBoxLayout">
-          <item>
-           <spacer>
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>40</width>
-              <height>20</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
-          <item>
-           <widget class="QLabel" name="labelVariant">
-            <property name="text">
-             <string>&amp;Variant:</string>
-            </property>
-            <property name="buddy">
-             <cstring>spinVariant</cstring>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QSpinBox" name="spinVariant">
-            <property name="cursor">
-             <cursorShape>PointingHandCursor</cursorShape>
-            </property>
-            <property name="statusTip">
-             <string>Number of variant</string>
-            </property>
-            <property name="minimum">
-             <number>1</number>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QLabel" name="labelCities">
-            <property name="text">
-             <string>&amp;Cities:</string>
-            </property>
-            <property name="buddy">
-             <cstring>spinCities</cstring>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QSpinBox" name="spinCities">
-            <property name="cursor">
-             <cursorShape>PointingHandCursor</cursorShape>
-            </property>
-            <property name="statusTip">
-             <string>Number of cities</string>
-            </property>
-            <property name="minimum">
-             <number>3</number>
-            </property>
-            <property name="maximum">
-             <number>5</number>
-            </property>
-            <property name="value">
-             <number>5</number>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <spacer>
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>40</width>
-              <height>20</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
-         </layout>
-        </item>
-        <item>
-         <widget class="QTableView" name="taskView">
+   <widget class="QTabWidget" name="tabWidget">
+    <property name="geometry">
+     <rect>
+      <x>0</x>
+      <y>0</y>
+      <width>481</width>
+      <height>311</height>
+     </rect>
+    </property>
+    <property name="sizePolicy">
+     <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+      <horstretch>0</horstretch>
+      <verstretch>0</verstretch>
+     </sizepolicy>
+    </property>
+    <property name="currentIndex">
+     <number>0</number>
+    </property>
+    <widget class="QWidget" name="tabTask">
+     <attribute name="title">
+      <string>Task</string>
+     </attribute>
+     <layout class="QVBoxLayout">
+      <item>
+       <layout class="QHBoxLayout">
+        <item>
+         <spacer>
+          <property name="orientation">
+           <enum>Qt::Horizontal</enum>
+          </property>
+          <property name="sizeHint" stdset="0">
+           <size>
+            <width>40</width>
+            <height>20</height>
+           </size>
+          </property>
+         </spacer>
+        </item>
+        <item>
+         <widget class="QLabel" name="labelVariant">
+          <property name="text">
+           <string>&amp;Variant:</string>
+          </property>
+          <property name="buddy">
+           <cstring>spinVariant</cstring>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QSpinBox" name="spinVariant">
+          <property name="cursor">
+           <cursorShape>PointingHandCursor</cursorShape>
+          </property>
           <property name="statusTip">
-           <string>Cost of travel from city to city</string>
-          </property>
-          <property name="selectionMode">
-           <enum>QAbstractItemView::NoSelection</enum>
+           <string>Number of variant</string>
+          </property>
+          <property name="minimum">
+           <number>1</number>
           </property>
          </widget>
         </item>
         <item>
-         <layout class="QHBoxLayout">
-          <item>
-           <spacer>
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>40</width>
-              <height>20</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
-          <item>
-           <widget class="QPushButton" name="buttonRandom">
-            <property name="cursor">
-             <cursorShape>PointingHandCursor</cursorShape>
-            </property>
-            <property name="statusTip">
-             <string>Fill table with random numbers</string>
-            </property>
-            <property name="text">
-             <string>Random</string>
-            </property>
-            <property name="icon">
-             <iconset resource="../resources/tspsg.qrc">
-              <normaloff>:/images/icons/roll.png</normaloff>:/images/icons/roll.png</iconset>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QPushButton" name="buttonSolve">
-            <property name="cursor">
-             <cursorShape>PointingHandCursor</cursorShape>
-            </property>
-            <property name="statusTip">
-             <string>Solve current task</string>
-            </property>
-            <property name="text">
-             <string>Solve</string>
-            </property>
-            <property name="icon">
-             <iconset resource="../resources/tspsg.qrc">
-              <normaloff>:/images/icons/button_ok.png</normaloff>:/images/icons/button_ok.png</iconset>
-            </property>
-           </widget>
-          </item>
-         </layout>
+         <widget class="QLabel" name="labelCities">
+          <property name="text">
+           <string>&amp;Cities:</string>
+          </property>
+          <property name="buddy">
+           <cstring>spinCities</cstring>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QSpinBox" name="spinCities">
+          <property name="cursor">
+           <cursorShape>PointingHandCursor</cursorShape>
+          </property>
+          <property name="statusTip">
+           <string>Number of cities</string>
+          </property>
+          <property name="minimum">
+           <number>3</number>
+          </property>
+          <property name="maximum">
+           <number>5</number>
+          </property>
+          <property name="value">
+           <number>5</number>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <spacer>
+          <property name="orientation">
+           <enum>Qt::Horizontal</enum>
+          </property>
+          <property name="sizeHint" stdset="0">
+           <size>
+            <width>40</width>
+            <height>20</height>
+           </size>
+          </property>
+         </spacer>
         </item>
        </layout>
-      </widget>
-      <widget class="QWidget" name="tabSolution">
-       <attribute name="title">
-        <string>Solution</string>
-       </attribute>
-       <layout class="QVBoxLayout">
-        <item>
-         <layout class="QHBoxLayout">
-          <property name="spacing">
-           <number>0</number>
-          </property>
-          <item>
-           <widget class="QTextEdit" name="textEdit">
-            <property name="sizePolicy">
-             <sizepolicy hsizetype="Fixed" vsizetype="Expanding">
-              <horstretch>0</horstretch>
-              <verstretch>0</verstretch>
-             </sizepolicy>
-            </property>
-            <property name="statusTip">
-             <string>Solution steps</string>
-            </property>
-            <property name="readOnly">
-             <bool>true</bool>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QGraphicsView" name="graphicsView">
-            <property name="statusTip">
-             <string>Solution graph</string>
-            </property>
-           </widget>
-          </item>
-         </layout>
+      </item>
+      <item>
+       <widget class="QTableView" name="taskView">
+        <property name="statusTip">
+         <string>Cost of travel from city to city</string>
+        </property>
+        <property name="selectionMode">
+         <enum>QAbstractItemView::NoSelection</enum>
+        </property>
+       </widget>
+      </item>
+      <item>
+       <layout class="QHBoxLayout">
+        <item>
+         <spacer>
+          <property name="orientation">
+           <enum>Qt::Horizontal</enum>
+          </property>
+          <property name="sizeHint" stdset="0">
+           <size>
+            <width>40</width>
+            <height>20</height>
+           </size>
+          </property>
+         </spacer>
+        </item>
+        <item>
+         <widget class="QPushButton" name="buttonRandom">
+          <property name="cursor">
+           <cursorShape>PointingHandCursor</cursorShape>
+          </property>
+          <property name="statusTip">
+           <string>Fill table with random numbers</string>
+          </property>
+          <property name="text">
+           <string>Random</string>
+          </property>
+          <property name="icon">
+           <iconset resource="../resources/tspsg.qrc">
+            <normaloff>:/images/icons/roll.png</normaloff>:/images/icons/roll.png</iconset>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QPushButton" name="buttonSolve">
+          <property name="cursor">
+           <cursorShape>PointingHandCursor</cursorShape>
+          </property>
+          <property name="statusTip">
+           <string>Solve current task</string>
+          </property>
+          <property name="text">
+           <string>Solve</string>
+          </property>
+          <property name="icon">
+           <iconset resource="../resources/tspsg.qrc">
+            <normaloff>:/images/icons/button_ok.png</normaloff>:/images/icons/button_ok.png</iconset>
+          </property>
+         </widget>
         </item>
        </layout>
-      </widget>
-     </widget>
-    </item>
-   </layout>
+      </item>
+     </layout>
+    </widget>
+    <widget class="QWidget" name="tabSolution">
+     <attribute name="title">
+      <string>Solution</string>
+     </attribute>
+     <layout class="QVBoxLayout" name="verticalLayout">
+      <item>
+       <widget class="QTextEdit" name="solutionText">
+        <property name="enabled">
+         <bool>false</bool>
+        </property>
+        <property name="statusTip">
+         <string>Solution steps</string>
+        </property>
+        <property name="readOnly">
+         <bool>true</bool>
+        </property>
+        <property name="textInteractionFlags">
+         <set>Qt::TextSelectableByKeyboard|Qt::TextSelectableByMouse</set>
+        </property>
+       </widget>
+      </item>
+     </layout>
+    </widget>
+   </widget>
   </widget>
   <widget class="QMenuBar" name="menubar">
@@ -227,6 +217,6 @@
      <x>0</x>
      <y>0</y>
-     <width>640</width>
-     <height>24</height>
+     <width>491</width>
+     <height>22</height>
     </rect>
    </property>
@@ -248,9 +238,6 @@
        <normaloff>:/images/icons/filesaveas.png</normaloff>:/images/icons/filesaveas.png</iconset>
      </property>
-     <addaction name="actionFileSaveTask"/>
-     <addaction name="separator"/>
-     <addaction name="actionFileSaveSolutionAll"/>
-     <addaction name="actionFileSaveSolutionMatrices"/>
-     <addaction name="actionFileSaveSolutionGraph"/>
+     <addaction name="actionFileSaveAsTask"/>
+     <addaction name="actionFileSaveAsSolution"/>
     </widget>
     <addaction name="actionFileNew"/>
@@ -276,5 +263,5 @@
      </property>
      <property name="title">
-      <string extracomment="Please, append &quot; / Language&quot; when translating this string.">&amp;Language</string>
+      <string comment="Please, append &quot; / Language&quot; when translating this string.">&amp;Language</string>
      </property>
      <property name="icon">
@@ -325,4 +312,7 @@
   </widget>
   <action name="actionFilePrintSetup">
+   <property name="enabled">
+    <bool>false</bool>
+   </property>
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
@@ -382,10 +372,10 @@
    </property>
   </action>
-  <action name="actionFileSaveSolutionAll">
-   <property name="enabled">
-    <bool>false</bool>
-   </property>
-   <property name="text">
-    <string>&amp;Solution</string>
+  <action name="actionFileSaveAsSolution">
+   <property name="enabled">
+    <bool>false</bool>
+   </property>
+   <property name="text">
+    <string>&amp;Solution...</string>
    </property>
    <property name="toolTip">
@@ -510,9 +500,5 @@
    </property>
   </action>
-  <action name="actionFileSaveTask">
-   <property name="icon">
-    <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/icons/filesaveas.png</normaloff>:/images/icons/filesaveas.png</iconset>
-   </property>
+  <action name="actionFileSaveAsTask">
    <property name="text">
     <string>&amp;Task...</string>
@@ -583,5 +569,5 @@
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
-     <normaloff>:/images/qtlogo-64.png</normaloff>:/images/qtlogo-64.png</iconset>
+     <normaloff>:/images/icons/qtlogo-64.png</normaloff>:/images/icons/qtlogo-64.png</iconset>
    </property>
    <property name="text">
Index: trunk/ui/settingsdialog.ce.ui
===================================================================
--- trunk/ui/settingsdialog.ce.ui	(revision 39)
+++ trunk/ui/settingsdialog.ce.ui	(revision 42)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>235</width>
-    <height>180</height>
+    <width>205</width>
+    <height>212</height>
    </rect>
   </property>
@@ -180,53 +180,45 @@
       </item>
       <item>
-       <layout class="QHBoxLayout" name="horizontalLayout_2">
-        <item>
-         <spacer name="horizontalSpacer_3">
-          <property name="orientation">
-           <enum>Qt::Horizontal</enum>
-          </property>
-          <property name="sizeHint" stdset="0">
-           <size>
-            <width>40</width>
-            <height>20</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-        <item>
-         <widget class="QPushButton" name="buttonColor">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>Font color for printing</string>
-          </property>
-          <property name="text">
-           <string>&amp;Color...</string>
-          </property>
-          <property name="icon">
-           <iconset resource="../resources/tspsg.qrc">
-            <normaloff>:/images/icons/color_line.png</normaloff>:/images/icons/color_line.png</iconset>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QPushButton" name="buttonFont">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>Font face for printing</string>
-          </property>
-          <property name="text">
-           <string>&amp;Font...</string>
-          </property>
-          <property name="icon">
-           <iconset resource="../resources/tspsg.qrc">
-            <normaloff>:/images/icons/fonts.png</normaloff>:/images/icons/fonts.png</iconset>
-          </property>
-         </widget>
-        </item>
-       </layout>
+       <widget class="QGroupBox" name="groupOutputSettings">
+        <property name="title">
+         <string>Output settings:</string>
+        </property>
+        <layout class="QHBoxLayout" name="horizontalLayout">
+         <item>
+          <widget class="QPushButton" name="buttonFont">
+           <property name="cursor">
+            <cursorShape>PointingHandCursor</cursorShape>
+           </property>
+           <property name="statusTip">
+            <string>Font face for printing</string>
+           </property>
+           <property name="text">
+            <string>&amp;Font...</string>
+           </property>
+           <property name="icon">
+            <iconset resource="../resources/tspsg.qrc">
+             <normaloff>:/images/icons/fonts.png</normaloff>:/images/icons/fonts.png</iconset>
+           </property>
+          </widget>
+         </item>
+         <item>
+          <widget class="QPushButton" name="buttonColor">
+           <property name="cursor">
+            <cursorShape>PointingHandCursor</cursorShape>
+           </property>
+           <property name="statusTip">
+            <string>Font color for printing</string>
+           </property>
+           <property name="text">
+            <string>&amp;Color...</string>
+           </property>
+           <property name="icon">
+            <iconset resource="../resources/tspsg.qrc">
+             <normaloff>:/images/icons/color_line.png</normaloff>:/images/icons/color_line.png</iconset>
+           </property>
+          </widget>
+         </item>
+        </layout>
+       </widget>
       </item>
       <item>
Index: trunk/ui/settingsdialog.ui
===================================================================
--- trunk/ui/settingsdialog.ui	(revision 39)
+++ trunk/ui/settingsdialog.ui	(revision 42)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>448</width>
-    <height>174</height>
+    <width>415</width>
+    <height>176</height>
    </rect>
   </property>
@@ -231,88 +231,42 @@
           </item>
           <item>
-           <widget class="QGroupBox" name="groupPrintSetup">
+           <widget class="QGroupBox" name="groupOutputSettings">
             <property name="title">
-             <string>Print settings:</string>
+             <string>Output settings:</string>
             </property>
             <layout class="QVBoxLayout" name="verticalLayout">
              <item>
-              <layout class="QHBoxLayout">
-               <item>
-                <widget class="QLabel" name="labelLeftMargin">
-                 <property name="sizePolicy">
-                  <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
-                   <horstretch>0</horstretch>
-                   <verstretch>0</verstretch>
-                  </sizepolicy>
-                 </property>
-                 <property name="text">
-                  <string>&amp;Left margin:</string>
-                 </property>
-                 <property name="buddy">
-                  <cstring>spinLeftMargin</cstring>
-                 </property>
-                </widget>
-               </item>
-               <item>
-                <widget class="QSpinBox" name="spinLeftMargin">
-                 <property name="cursor">
-                  <cursorShape>PointingHandCursor</cursorShape>
-                 </property>
-                 <property name="statusTip">
-                  <string>Left border margin for page</string>
-                 </property>
-                 <property name="maximum">
-                  <number>999</number>
-                 </property>
-                 <property name="singleStep">
-                  <number>10</number>
-                 </property>
-                 <property name="value">
-                  <number>100</number>
-                 </property>
-                </widget>
-               </item>
-              </layout>
+              <widget class="QPushButton" name="buttonFont">
+               <property name="cursor">
+                <cursorShape>PointingHandCursor</cursorShape>
+               </property>
+               <property name="statusTip">
+                <string>Font face for printing</string>
+               </property>
+               <property name="text">
+                <string>&amp;Font...</string>
+               </property>
+               <property name="icon">
+                <iconset resource="../resources/tspsg.qrc">
+                 <normaloff>:/images/icons/fonts.png</normaloff>:/images/icons/fonts.png</iconset>
+               </property>
+              </widget>
              </item>
              <item>
-              <layout class="QHBoxLayout" name="horizontalLayout">
-               <property name="spacing">
-                <number>0</number>
-               </property>
-               <item>
-                <widget class="QPushButton" name="buttonColor">
-                 <property name="cursor">
-                  <cursorShape>PointingHandCursor</cursorShape>
-                 </property>
-                 <property name="statusTip">
-                  <string>Font color for printing</string>
-                 </property>
-                 <property name="text">
-                  <string>&amp;Color...</string>
-                 </property>
-                 <property name="icon">
-                  <iconset resource="../resources/tspsg.qrc">
-                   <normaloff>:/images/icons/color_line.png</normaloff>:/images/icons/color_line.png</iconset>
-                 </property>
-                </widget>
-               </item>
-               <item>
-                <widget class="QPushButton" name="buttonFont">
-                 <property name="cursor">
-                  <cursorShape>PointingHandCursor</cursorShape>
-                 </property>
-                 <property name="statusTip">
-                  <string>Font face for printing</string>
-                 </property>
-                 <property name="text">
-                  <string>&amp;Font...</string>
-                 </property>
-                 <property name="icon">
-                  <iconset resource="../resources/tspsg.qrc">
-                   <normaloff>:/images/icons/fonts.png</normaloff>:/images/icons/fonts.png</iconset>
-                 </property>
-                </widget>
-               </item>
-              </layout>
+              <widget class="QPushButton" name="buttonColor">
+               <property name="cursor">
+                <cursorShape>PointingHandCursor</cursorShape>
+               </property>
+               <property name="statusTip">
+                <string>Font color for printing</string>
+               </property>
+               <property name="text">
+                <string>&amp;Color...</string>
+               </property>
+               <property name="icon">
+                <iconset resource="../resources/tspsg.qrc">
+                 <normaloff>:/images/icons/color_line.png</normaloff>:/images/icons/color_line.png</iconset>
+               </property>
+              </widget>
              </item>
             </layout>
@@ -400,4 +354,16 @@
         </sizepolicy>
        </property>
+       <property name="minimumSize">
+        <size>
+         <width>0</width>
+         <height>28</height>
+        </size>
+       </property>
+       <property name="maximumSize">
+        <size>
+         <width>16777215</width>
+         <height>28</height>
+        </size>
+       </property>
        <property name="statusTip">
         <string>Hover mouse pointer over dialog elements to get additional help</string>
@@ -460,4 +426,12 @@
  <resources>
   <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
+  <include location="../resources/tspsg.qrc"/>
  </resources>
  <connections/>